
close all
clear all
clc
aa=1; %set the seed for reproducibility



      rand('twister', 5493+aa);
      randn('state', 3+aa);
      randn('seed',3+aa);
      rand('seed',3+aa);

  %generate the data set:    
     m2a=6;m2b=6.5;m2c=7; 
     m1a=6;m1b=7.5;m1c=8.5; 
       
     s=1;
     s1a=s;s1b=s;s1c=s;
     s2a=s;s2b=s;s2c=s;
     na=100;
     nb=100;
     nc=100;
                    
    mycov=0.4;
Wa=mvnrnd([m1a m2a]',[s1a^2 mycov;mycov s2a^2],na);
Wb=mvnrnd([m1b m2b]',[s1b^2 mycov;mycov s2b^2],nb);
Wc=mvnrnd([m1c m2c]',[s1c^2 mycov;mycov s2c^2],nc);

W1a=Wa(:,1);W2a=Wa(:,2);
W1b=Wb(:,1);W2b=Wb(:,2);
W1c=Wc(:,1);W2c=Wc(:,2);

W1=[W1a;W1b;W1c];
W2=[W2a;W2b;W2c];


D=[zeros(na,1)+1;ones(nb,1)+1;ones(nc,1)+2];

%=======AVAILABLE DATA TO BE ANALYZED===============================
W1;W2;D;
%===================================================================


%% Make a comparison for TCA=0.5 and TCC=0.6 using the normality assumption:
close all
clc

[distance, pval2t, Z, ROC1, ROC2, vus1, vus2, CIdiff]=roc3dcompare(W1,W2,D,[0.5 NaN 0.6],'normal');



%% Make a comparison for TCA=0.5 and TCC=0.6 using the box-cox:
close all
clc
init=[mean(W1a) sqrt(var(W1a)) mean(W1b) sqrt(var(W1b)) mean(W1c) sqrt(var(W1c)) mean(W2a) sqrt(var(W2a)) mean(W2b) sqrt(var(W2b)) mean(W2c) sqrt(var(W2c))  0.5 0.5 0.5 1 1];
[distance, pval2t, Z, ROC1, ROC2, vus1, vus2, CIdiff]=roc3dcompare(W1,W2,D,[0.5 NaN 0.6],'boxcox',init);

%% Make a comparison for TCA=0.5 and TCC=0.6 using the kernels:
close all
clc
[distance, pval2t, Z, ROC1, ROC2, vus1, vus2, CIdiff]=roc3dcompare(W1,W2,D,[0.5 NaN 0.6],'kernels');







%% Make a comparison for TCA=0.3 and TCB=0.4 using the normality assumption:
close all
clc

[distance, pval2t, Z, ROC1, ROC2, vus1, vus2, CIdiff]=roc3dcompare(W1,W2,D,[0.3 0.4 NaN],'normal');



%% Make a comparison for TCA=0.3 and TCB=0.4 using the box-cox:
close all
clc
init=[mean(W1a) sqrt(var(W1a)) mean(W1b) sqrt(var(W1b)) mean(W1c) sqrt(var(W1c)) mean(W2a) sqrt(var(W2a)) mean(W2b) sqrt(var(W2b)) mean(W2c) sqrt(var(W2c))  0.5 0.5 0.5 1 1];
[distance, pval2t, Z, ROC1, ROC2, vus1, vus2, CIdiff]=roc3dcompare(W1,W2,D,[0.3 0.4 NaN],'boxcox');

%% Make a comparison for TCA=0.3 and TCB=0.4 using the kernels:
close all
clc
[distance, pval2t, Z, ROC1, ROC2, vus1, vus2, CIdiff]=roc3dcompare(W1,W2,D,[0.3 0.4 NaN],'kernels');









