function  [distance, pvalue2t, Zstar, ROC1, ROC2, vus1, vus2, CIdiff]=roc3dboxcox_ab(W1,W2,D,tripletabc,init)


W1a=W1(D==1);
W1b=W1(D==2);
W1c=W1(D==3);

W2a=W2(D==1);
W2b=W2(D==2);
W2c=W2(D==3);

na=length(W1a);
nb=length(W1b);
nc=length(W1c);

Wa=[W1a W2a];
Wb=[W1b W2b];
Wc=[W1c W2c];


if length(find(isnan(tripletabc)))~=1
    error('the tripletabc should have exactly one NaN value so that a pair is defined')
end

t=tripletabc(find(~isnan(tripletabc)));
att1=t(1);
att2=t(2);

%====================================================

%====================================================


ca=cov([W1a W2a]);cova=ca(1,2);
cb=cov([W1b W2b]);covb=cb(1,2);
cc=cov([W1c W2c]);covc=cc(1,2);

%init=[mean(W1a) sqrt(var(W1a)) mean(W1b) sqrt(var(W1b)) mean(W1c) sqrt(var(W1c)) mean(W2a) sqrt(var(W2a)) mean(W2b) sqrt(var(W2b)) mean(W2c) sqrt(var(W2c))  cova covb covc];

options=optimset('MaxFunEvals',1000000,'MaxIter',1000000,'TolX',10^(-10));


%=====BOX-COX===============================================================
W1alam=@(lam) (W1a.^lam-1)./lam;
W2alam=@(lam) (W2a.^lam-1)./lam;
W1blam=@(lam) (W1b.^lam-1)./lam;
W2blam=@(lam) (W2b.^lam-1)./lam;
W1clam=@(lam) (W1c.^lam-1)./lam;
W2clam=@(lam) (W2c.^lam-1)./lam;


minusL=@(g) (-sum(log(mvnpdf2([W1alam(g(16)) W2alam(g(17))],[g(1) g(7)],[g(2).^2 g(13) ;g(13)  g(8).^2]))) -...
              sum(log(mvnpdf2([W1blam(g(16)) W2blam(g(17))],[g(3) g(9)],[g(4).^2 g(14);g(14) g(10).^2]))) -...
              sum(log(mvnpdf2([W1clam(g(16)) W2clam(g(17))],[g(5) g(11)],[g(6).^2 g(15);g(15) g(12).^2])))+...
              -(g(16)-1).*sum(log(W1a))-(g(17)-1).*sum(log(W2a))-(g(16)-1).*sum(log(W1b))-(g(17)-1).*sum(log(W2b))-(g(16)-1).*sum(log(W1c))-(g(17)-1).*sum(log(W2c)));       

if nargin<5          
init=[mean(W1a) sqrt(var(W1a)) mean(W1b) sqrt(var(W1b)) mean(W1c) sqrt(var(W1c)) mean(W2a) sqrt(var(W2a)) mean(W2b) sqrt(var(W2b)) mean(W2c) sqrt(var(W2c))  cova covb covc 1 1];
end

L=@(g) -(-sum(log(mvnpdf2([W1alam(g(16)) W2alam(g(17))],[g(1) g(7)],[g(2).^2 g(13) ;g(13)  g(8).^2]))) -...
          sum(log(mvnpdf2([W1blam(g(16)) W2blam(g(17))],[g(3) g(9)],[g(4).^2 g(14);g(14) g(10).^2]))) -...
          sum(log(mvnpdf2([W1clam(g(16)) W2clam(g(17))],[g(5) g(11)],[g(6).^2 g(15);g(15) g(12).^2])))+...
          -(g(16)-1).*sum(log(W1a))-(g(17)-1).*sum(log(W2a))-(g(16)-1).*sum(log(W1b))-(g(17)-1).*sum(log(W2b))-(g(16)-1).*sum(log(W1c))-(g(17)-1).*sum(log(W2c)));       


[g, gval, exitflag]=fminsearchbnd(minusL,[init],[-Inf 0 -Inf 0 -Inf 0    -Inf 0 -Inf 0 -Inf 0   -Inf -Inf -Inf -Inf -Inf],[ Inf.*ones(1,17)],options);

Hcf=HcfBC(W1a, W2a, W1b, W2b, W1c, W2c, [na nb nc], g);
%              1   2   3   4   5   6   7   8   9    10   11   12   13   14   15  16    17
%with order:  m1a s1a m1b s1b m1c s1c m2a s2a m2b  s2b  m2c  s2c  cova covb covc lam1 lam2 
%-->their lambda versions
VV=inv(-Hcf);
m1ahat=g(1);s1ahat=g(2);
m1bhat=g(3);s1bhat=g(4);
m1chat=g(5);s1chat=g(6);

m2ahat=g(7);s2ahat=g(8);
m2bhat=g(9);s2bhat=g(10);
m2chat=g(11);s2chat=g(12);

cova=g(13);covb=g(14);covc=g(15);
lam1=g(16);lam2=g(17);



%===============================END HESSIAN IN CLOSED FORM


pars=[m1ahat s1ahat m1bhat s1bhat m1chat s1chat m2ahat s2ahat m2bhat s2bhat m2chat s2chat];

ROCsurf1=@(p1,p3) (norminv(1-p3,m1chat,s1chat)>norminv(p1,m1ahat,s1ahat)).*(normcdf(norminv(1-p3,m1chat,s1chat),m1bhat,s1bhat)-normcdf(norminv(p1,m1ahat,s1ahat),m1bhat,s1bhat));


% ROC1=@(p1,p3) (normcdf((s1chat*norminv(1-p3)+m1chat-m1bhat)./(s1bhat))-...
%                normcdf((s1ahat*norminv(p1  )+m1ahat-m1bhat)./(s1bhat))).*(((s1chat*norminv(1-p3)+m1chat-m1bhat)./(s1bhat))>((s1ahat*norminv(p1  )+m1ahat-m1bhat)./(s1bhat)));
% 
% ROC2=@(p1,p3) (normcdf((s2chat*norminv(1-p3)+m2chat-m2bhat)./(s2bhat))-...
%               normcdf((s2ahat*norminv(p1  )+m2ahat-m2bhat)./(s2bhat))).*(((s2chat*norminv(1-p3)+m2chat-m2bhat)./(s2bhat))>((s2ahat*norminv(p1  )+m2ahat-m2bhat)./(s2bhat)));

ROC1point=@(p1,p2) normcdf(-(1/s1chat*((norminv(p2+normcdf(norminv(p1,m1ahat,s1ahat),m1bhat,s1bhat),m1bhat,s1bhat))-m1chat)));
ROC2point=@(p1,p2) normcdf(-(1/s2chat*((norminv(p2+normcdf(norminv(p1,m2ahat,s2ahat),m2bhat,s2bhat),m2bhat,s2bhat))-m2chat)));
ROC1=ROC1point(att1,att2);
ROC2=ROC2point(att1,att2);

ROC1MC =norminv(ROC1point(att1,att2));
ROC2MC =norminv(ROC2point(att1,att2));


p1=att1;p2=att2;
%====================ROC1==============================

dm1ahat =-(exp(erfcinv(erf((2^(1/2)*(m1bhat - m1ahat + 2^(1/2)*s1ahat*erfcinv(2*p1)))/(2*s1bhat)) - 2*p2 + 1)^2)*exp(-(m1bhat - m1ahat + 2^(1/2)*s1ahat*erfcinv(2*p1))^2/(2*s1bhat^2)))/s1chat;
ds1ahat =(2^(1/2)*erfcinv(2*p1)*exp(erfcinv(erf((2^(1/2)*(m1bhat - m1ahat + 2^(1/2)*s1ahat*erfcinv(2*p1)))/(2*s1bhat)) - 2*p2 + 1)^2)*exp(-(m1bhat - m1ahat + 2^(1/2)*s1ahat*erfcinv(2*p1))^2/(2*s1bhat^2)))/s1chat;
dm1bhat =(exp(erfcinv(erf((2^(1/2)*(m1bhat - m1ahat + 2^(1/2)*s1ahat*erfcinv(2*p1)))/(2*s1bhat)) - 2*p2 + 1)^2)*exp(-(m1bhat - m1ahat + 2^(1/2)*s1ahat*erfcinv(2*p1))^2/(2*s1bhat^2)) - 1)/s1chat;
ds1bhat =-(2^(1/2)*erfcinv(erf((2^(1/2)*(m1bhat - m1ahat + 2^(1/2)*s1ahat*erfcinv(2*p1)))/(2*s1bhat)) - 2*p2 + 1) + (exp(erfcinv(erf((2^(1/2)*(m1bhat - m1ahat + 2^(1/2)*s1ahat*erfcinv(2*p1)))/(2*s1bhat)) - 2*p2 + 1)^2)*exp(-(m1bhat - m1ahat + 2^(1/2)*s1ahat*erfcinv(2*p1))^2/(2*s1bhat^2))*(m1bhat - m1ahat + 2^(1/2)*s1ahat*erfcinv(2*p1)))/s1bhat)/s1chat;
dm1chat =1/s1chat;
ds1chat =(m1bhat - m1chat + 2^(1/2)*s1bhat*erfcinv(erf((2^(1/2)*(m1bhat - m1ahat + 2^(1/2)*s1ahat*erfcinv(2*p1)))/(2*s1bhat)) - 2*p2 + 1))/s1chat^2;
 
  
varROC1 =[dm1ahat ds1ahat dm1bhat ds1bhat dm1chat ds1chat]*VV(1:6,1:6)*[dm1ahat ds1ahat dm1bhat ds1bhat dm1chat ds1chat]';

%====================ROC2==============================
dm2ahat =-(exp(erfcinv(erf((2^(1/2)*(m2bhat - m2ahat + 2^(1/2)*s2ahat*erfcinv(2*p1)))/(2*s2bhat)) - 2*p2 + 1)^2)*exp(-(m2bhat - m2ahat + 2^(1/2)*s2ahat*erfcinv(2*p1))^2/(2*s2bhat^2)))/s2chat;
ds2ahat =(2^(1/2)*erfcinv(2*p1)*exp(erfcinv(erf((2^(1/2)*(m2bhat - m2ahat + 2^(1/2)*s2ahat*erfcinv(2*p1)))/(2*s2bhat)) - 2*p2 + 1)^2)*exp(-(m2bhat - m2ahat + 2^(1/2)*s2ahat*erfcinv(2*p1))^2/(2*s2bhat^2)))/s2chat;
dm2bhat =(exp(erfcinv(erf((2^(1/2)*(m2bhat - m2ahat + 2^(1/2)*s2ahat*erfcinv(2*p1)))/(2*s2bhat)) - 2*p2 + 1)^2)*exp(-(m2bhat - m2ahat + 2^(1/2)*s2ahat*erfcinv(2*p1))^2/(2*s2bhat^2)) - 1)/s2chat;
ds2bhat =-(2^(1/2)*erfcinv(erf((2^(1/2)*(m2bhat - m2ahat + 2^(1/2)*s2ahat*erfcinv(2*p1)))/(2*s2bhat)) - 2*p2 + 1) + (exp(erfcinv(erf((2^(1/2)*(m2bhat - m2ahat + 2^(1/2)*s2ahat*erfcinv(2*p1)))/(2*s2bhat)) - 2*p2 + 1)^2)*exp(-(m2bhat - m2ahat + 2^(1/2)*s2ahat*erfcinv(2*p1))^2/(2*s2bhat^2))*(m2bhat - m2ahat + 2^(1/2)*s2ahat*erfcinv(2*p1)))/s2bhat)/s2chat;
dm2chat =1/s2chat;
ds2chat =(m2bhat - m2chat + 2^(1/2)*s2bhat*erfcinv(erf((2^(1/2)*(m2bhat - m2ahat + 2^(1/2)*s2ahat*erfcinv(2*p1)))/(2*s2bhat)) - 2*p2 + 1))/s2chat^2;
   
varROC2 =[dm2ahat ds2ahat dm2bhat ds2bhat dm2chat ds2chat]*VV(7:12,7:12)*[dm2ahat ds2ahat dm2bhat ds2bhat dm2chat ds2chat]';

%====================cov ROC2==============================

covROC =[dm1ahat ds1ahat dm1bhat ds1bhat dm1chat ds1chat 0 0 0 0 0 0]*VV(1:12,1:12)*[0 0 0 0 0 0 dm2ahat ds2ahat dm2bhat ds2bhat dm2chat ds2chat]';


Z =(ROC2MC -ROC1MC )./(sqrt(varROC1 +varROC2 -2*covROC ));

SE=sqrt(varROC1 +varROC2 -2*covROC );
CIdiff=[(ROC2MC -ROC1MC )-1.96*SE (ROC2MC -ROC1MC )+1.96*SE];
sortci=sort(CIdiff);


ROCsurf1=@(p1,p3) (norminv(1-p3,m1chat,s1chat)>norminv(p1,m1ahat,s1ahat)).*(normcdf(norminv(1-p3,m1chat,s1chat),m1bhat,s1bhat)-normcdf(norminv(p1,m1ahat,s1ahat),m1bhat,s1bhat));
ROCsurf2=@(p1,p3) (norminv(1-p3,m2chat,s2chat)>norminv(p1,m2ahat,s2ahat)).*(normcdf(norminv(1-p3,m2chat,s2chat),m2bhat,s2bhat)-normcdf(norminv(p1,m2ahat,s2ahat),m2bhat,s2bhat));
vus1=integral2(ROCsurf1,0,1,0,1);
vus2=integral2(ROCsurf2,0,1,0,1);



Z;
SE;
Zstar=Z;
pvalue2t=2*normcdf(-abs(Z));







%----plot the ROC surface:
[p1,p3] = meshgrid(0:0.01:1, 0:0.01:1);
ROCsparam= (norminv(1-p3,m1chat,s1chat)>norminv(p1,m1ahat,s1ahat)).*(normcdf(norminv(1-p3,m1chat,s1chat),m1bhat,s1bhat)-normcdf(norminv(p1,m1ahat,s1ahat),m1bhat,s1bhat));
surf(p1,p3,ROCsparam) %plot the ROC surface
hold on
xlabel('p_{A}');ylabel('p_{C}');zlabel('p_{B}');

shading interp
axis vis3d
colormap hot

freezeColors
cbfreeze(colorbar)
str1 = sprintf('Marker 1, VUS_{1} = %4f  , TC_{C} at given pair= %4f',vus1,ROC1point(att1,att2));
cblabel(str1)
%-------------------
ROCsparam= (norminv(1-p3,m2chat,s2chat)>norminv(p1,m2ahat,s2ahat)).*(normcdf(norminv(1-p3,m2chat,s2chat),m2bhat,s2bhat)-normcdf(norminv(p1,m2ahat,s2ahat),m2bhat,s2bhat));
RR=ROCsparam;
surf(p1,p3,ROCsparam) %plot the ROC surface
xlabel('TC_{A}');ylabel('TC_{C}');zlabel('TC_{B}');

shading interp
alpha(0.7)
colormap winter
freezeColors
h1=colorbar('Location','westoutside');
str2 = sprintf('Marker 2, VUS_{2} = %4f  , TC_{C} at given pair= %4f',vus2,ROC2point(att1,att2));
cblabel(str2)


ROCsurf1=@(p1,p3) (norminv(1-p3,m1chat,s1chat)>norminv(p1,m1ahat,s1ahat)).*(normcdf(norminv(1-p3,m1chat,s1chat),m1bhat,s1bhat)-normcdf(norminv(p1,m1ahat,s1ahat),m1bhat,s1bhat));
ROCsurf2=@(p1,p3) (norminv(1-p3,m2chat,s2chat)>norminv(p1,m2ahat,s2ahat)).*(normcdf(norminv(1-p3,m2chat,s2chat),m2bhat,s2bhat)-normcdf(norminv(p1,m2ahat,s2ahat),m2bhat,s2bhat));

ROC1point=@(p1,p2) normcdf(-(1/s1chat*((norminv(p2+normcdf(norminv(p1,m1ahat,s1ahat),m1bhat,s1bhat),m1bhat,s1bhat))-m1chat)));
ROC2point=@(p1,p2) normcdf(-(1/s2chat*((norminv(p2+normcdf(norminv(p1,m2ahat,s2ahat),m2bhat,s2bhat),m2bhat,s2bhat))-m2chat)));


plot3(att1,0,att2,'*r','LineWidth',1)
plot3(att1,1,att2,'*r','LineWidth',1)

if ROC1point(att1,att2)<ROC2point(att1,att2)
    plot3([att1 att1],[0 ROC1point(att1,att2)],[att2 att2],'--g')
    plot3([att1 att1],[ROC2point(att1,att2) 1],[att2 att2],'--g')
else
    plot3([att1 att1],[0 ROC2point(att1,att2)],[att2 att2],'--g')
    plot3([att1 att1],[ROC1point(att1,att2) 1],[att2 att2],'--g')
end


vus1=integral2(ROCsurf1,0,1,0,1);
plot3(att1,ROC1point(att1,att2),att2,'or','LineWidth',1)



vus2=integral2(ROCsurf2,0,1,0,1);
plot3(att1,ROC2point(att1,att2),att2,'or','LineWidth',1)
plot3([att1 att1],[ROC1point(att1,att2) ROC2point(att1,att2)],[att2 att2], 'r','LineWidth',2)

distance=abs(ROC1point(att1,att2)-ROC2point(att1,att2));


str = sprintf('ROC surfaces, Distance (red) at the given TC pair is= %4f\n ',distance);
title(str);

%=============PROJECTED ROC CURVES==========================
figure
subplot(2,2,1)
t=0:0.01:1;
roct=@(t) 1-normcdf(norminv(t,m2ahat,s2ahat),m2chat,s2chat);
plot(t,roct(t),'b','LineWidth',2)
auc2=quadgk(@(t) roct(t),0,1);
hold on
roct=@(t) 1-normcdf(norminv(t,m1ahat,s1ahat),m1chat,s1chat);
plot(t,roct(t),'r','LineWidth',2)
auc1=quadgk(@(t) roct(t),0,1);
xlabel('TC_{A}')
ylabel('TC_{C}')
legend(['AUC=' num2str(auc2)],['AUC=' num2str(auc1)],'Location','SouthWest');
title('ROC_{AC}')

subplot(2,2,2)
t=0:0.01:1;
roct=@(t) 1-normcdf(norminv(t,m2ahat,s2ahat),m2bhat,s2bhat);
plot(t,roct(t),'b','LineWidth',2)
auc2=quadgk(@(t) roct(t),0,1);
hold on
roct=@(t) 1-normcdf(norminv(t,m1ahat,s1ahat),m1bhat,s1bhat);
plot(t,roct(t),'r','LineWidth',2)
auc1=quadgk(@(t) roct(t),0,1);
xlabel('TC_{A}')
ylabel('TC_{B}')
legend(['AUC=' num2str(auc2)],['AUC=' num2str(auc1)],'Location','SouthWest');
title('ROC_{AB}')


subplot(2,2,3)
t=0:0.01:1;
roct=@(t) 1-normcdf(norminv(t,m2bhat,s2bhat),m2chat,s2chat);
plot(t,roct(t),'b','LineWidth',2)
auc2=quadgk(@(t) roct(t),0,1);
hold on
roct=@(t) 1-normcdf(norminv(t,m1bhat,s1bhat),m1chat,s1chat);
plot(t,roct(t),'r','LineWidth',2)
auc1=quadgk(@(t) roct(t),0,1);
xlabel('TC_{B}')
ylabel('TC_{C}')
legend(['AUC=' num2str(auc2)],['AUC=' num2str(auc1)],'Location','SouthWest');
title('ROC_{BC}')


subplot(2,2,4)
plot(att1,att2,'*r','LineWidth',1)
hold on
legend('Given pair')
t=0:0.01:1;
roct1=@(t) 1-normcdf(norminv(t,m2ahat,s2ahat),m2bhat,s2bhat);
roct2=@(t) 1-normcdf(norminv(t,m1ahat,s1ahat),m1bhat,s1bhat);

xx=[0 0  t 1 0];
yy=[0 1 min(roct2(t),roct1(t)) 0 0];
plot(xx,yy,'g','LineWidth',2)
hold on

xlabel('TC_{A}')
ylabel('TC_{B}')
title('Region of Feasible Given Pairs (green region)')
fill(xx,yy,'g')
plot(att1,att2,'*r','LineWidth',1)



end