function  [distance, pvalue2t, Zstar, ROC1or, ROC2or, vus1, vus2, CIdiff]=roc3dkernel_ab(W1,W2,D,tripletabc)


W1a=W1(D==1);
W1b=W1(D==2);
W1c=W1(D==3);

W2a=W2(D==1);
W2b=W2(D==2);
W2c=W2(D==3);

na=length(W1a);
nb=length(W1b);
nc=length(W1c);

Wa=[W1a W2a];
Wb=[W1b W2b];
Wc=[W1c W2c];


if length(find(isnan(tripletabc)))~=1
    error('the tripletabc should have exactly one NaN value so that a pair is defined')
end

t=tripletabc(find(~isnan(tripletabc)));
att1=t(1);
att2=t(2);

%====================================================

%====================================================


D=[zeros(na,1);ones(nb,1);ones(nc,1)+1];
ca=cov([W1a W2a]);cova=ca(1,2);
cb=cov([W1b W2b]);covb=cb(1,2);
cc=cov([W1c W2c]);covc=cc(1,2);

%init=[mean(W1a) sqrt(var(W1a)) mean(W1b) sqrt(var(W1b)) mean(W1c) sqrt(var(W1c)) mean(W2a) sqrt(var(W2a)) mean(W2b) sqrt(var(W2b)) mean(W2c) sqrt(var(W2c))  cova covb covc];

options=optimset('MaxFunEvals',1000000,'MaxIter',1000000,'TolX',10^(-10));





%===========START KERNEL ESTIMATION:=============
corrhata=corr([W1a W2a]);corrhata=corrhata(1,2);
h1a=std(W1a)*(1-corrhata^2)^(5/12)*(1+corrhata^2/2)^(-1/6)*na^(-1/6);
h2a=std(W2a)*(1-corrhata^2)^(5/12)*(1+corrhata^2/2)^(-1/6)*na^(-1/6);

corrhatb=corr([W1b W2b]);corrhatb=corrhatb(1,2);
h1b=std(W1b)*(1-corrhatb^2)^(5/12)*(1+corrhatb^2/2)^(-1/6)*nb^(-1/6);
h2b=std(W2b)*(1-corrhatb^2)^(5/12)*(1+corrhatb^2/2)^(-1/6)*nb^(-1/6);

corrhatc=corr([W1c W2c]);corrhatc=corrhatc(1,2);
h1c=std(W1c)*(1-corrhatc^2)^(5/12)*(1+corrhatc^2/2)^(-1/6)*nc^(-1/6);
h2c=std(W2c)*(1-corrhatc^2)^(5/12)*(1+corrhatc^2/2)^(-1/6)*nc^(-1/6);

F1ahat=@(g) mykernel(W1a,g,h1a);
F2ahat=@(g) mykernel(W2a,g,h2a);

F1bhat=@(g) mykernel(W1b,g,h1b);
F2bhat=@(g) mykernel(W2b,g,h2b);

F1chat=@(g) mykernel(W1c,g,h1c);
F2chat=@(g) mykernel(W2c,g,h2c);

Finv1ahat=@(g) myinvkernel(W1a,g,h1a);
Finv2ahat=@(g) myinvkernel(W2a,g,h2a);

Finv1bhat=@(g) myinvkernel(W1b,g,h1b);
Finv2bhat=@(g) myinvkernel(W2b,g,h2b);

Finv1chat=@(g) myinvkernel(W1c,g,h1c);
Finv2chat=@(g) myinvkernel(W2c,g,h2c);

%ROCk= 1-F1chat(Finv1bhat(p2+F1bhat(Finv1ahat(p1))));

ROC1point=@(p1,p2) 1-F1chat(Finv1bhat(p2+F1bhat(Finv1ahat(p1))));
ROC1=(ROC1point(t(1),t(2)));
ROC1or=ROC1;

ROC2point=@(p1,p2) 1-F2chat(Finv2bhat(p2+F2bhat(Finv2ahat(p1))));
ROC2=(ROC2point(t(1),t(2)));
ROC2or=ROC2;
    boots=1;
while boots<=400
    
    boots;
    if boots==100 || boots==200 || boots==300 || boots==400
        boots
    end
    ata=randsample(1:na,na,'true');
    atb=randsample(1:nb,nb,'true');
    atc=randsample(1:nc,nc,'true');
    
        
    corrhata=corr([W1a(ata) W2a(ata)]);corrhata=corrhata(1,2);
    h1a=std(W1a(ata))*(1-corrhata^2)^(5/12)*(1+corrhata^2/2)^(-1/6)*na^(-1/6);
    h2a=std(W2a(ata))*(1-corrhata^2)^(5/12)*(1+corrhata^2/2)^(-1/6)*na^(-1/6);

    corrhatb=corr([W1b(atb) W2b(atb)]);corrhatb=corrhatb(1,2);
    h1b=std(W1b(atb))*(1-corrhatb^2)^(5/12)*(1+corrhatb^2/2)^(-1/6)*nb^(-1/6);
    h2b=std(W2b(atb))*(1-corrhatb^2)^(5/12)*(1+corrhatb^2/2)^(-1/6)*nb^(-1/6);

    corrhatc=corr([W1c(atc) W2c(atc)]);corrhatc=corrhatc(1,2);
    h1c=std(W1c(atc))*(1-corrhatc^2)^(5/12)*(1+corrhatc^2/2)^(-1/6)*nc^(-1/6);
    h2c=std(W2c(atc))*(1-corrhatc^2)^(5/12)*(1+corrhatc^2/2)^(-1/6)*nc^(-1/6);

    W1aboots=W1a(ata);
    W1bboots=W1b(atb);
    W1cboots=W1c(atc);
    W2aboots=W2a(ata);
    W2bboots=W2b(atb);
    W2cboots=W2c(atc);
      
    
    F1ahatboots=@(g) mykernel(W1aboots,g,h1a);
    F2ahatboots=@(g) mykernel(W2aboots,g,h2a);

    F1bhatboots=@(g) mykernel(W1bboots,g,h1b);
    F2bhatboots=@(g) mykernel(W2bboots,g,h2b);

    F1chatboots=@(g) mykernel(W1cboots,g,h1c);
    F2chatboots=@(g) mykernel(W2cboots,g,h2c);

    Finv1ahatboots=@(g) myinvkernel(W1aboots,g,h1a);
    Finv2ahatboots=@(g) myinvkernel(W2aboots,g,h2a);

    Finv1bhatboots=@(g) myinvkernel(W1bboots,g,h1b);
    Finv2bhatboots=@(g) myinvkernel(W2bboots,g,h2b);

    Finv1chatboots=@(g) myinvkernel(W1cboots,g,h1c);
    Finv2chatboots=@(g) myinvkernel(W2cboots,g,h2c);

    ROC1pointboots= 1-F1chatboots(Finv1bhatboots(t(2)+F1bhatboots(Finv1ahatboots(t(1)))));
    ROC1boots(boots)=(ROC1pointboots);

    ROC2pointboots= 1-F2chatboots(Finv2bhatboots(t(2)+F2bhatboots(Finv2ahatboots(t(1)))));
    ROC2boots(boots)=(ROC2pointboots);

    if ROC1boots(boots)>0.01 && ROC2boots(boots)>0.01;
        boots=boots+1;
    end
end




covroc=cov([norminv(ROC1boots)' norminv(ROC2boots)']);
vinvROC1=covroc(1,1);vinvROC2=covroc(2,2);covrocinv=covroc(1,2);
clear ROC1boots ROC2boots
Z=(norminv(ROC2)-norminv(ROC1))./sqrt(vinvROC1+vinvROC2-2*covrocinv);
    
SE=sqrt(vinvROC1+vinvROC2-2*covrocinv);
CIdiff=[(norminv(ROC2)-norminv(ROC1))-1.96*SE  (norminv(ROC2)-norminv(ROC1))+1.96*SE];

Z;Zstar=Z;
CIdiff;
pvalue2t=2*normcdf(-abs(Z));





















%========================START PLOTTING==========================
%Monte Carlo

clear h1a h1b h1c h2a h2b h2c

ROC1point=@(p1,p3) (Finv1chat(1-p3)>Finv1ahat(p1)).*(F1bhat(Finv1chat(1-p3))-F1bhat(Finv1ahat(p1)));
[pp1,pp3] = meshgrid(0:0.01:1, 0:0.01:1);
p1=pp1(1:end)';
p3=pp3(1:end)';
rr1=ROC1point(p1,p3);

p1=reshape(p1,size(pp1,1),size(pp1,2));
p3=reshape(p3,size(pp3,1),size(pp3,2));
rr1=reshape(rr1,size(pp1,1),size(pp1,2));

surf(p1,p3,rr1)
vus1=trapz((0:0.01:1)',trapz((0:0.01:1)',rr1,2),1);

hold on
xlabel('p_{A}');ylabel('p_{C}');zlabel('p_{B}');

shading interp
axis vis3d
colormap hot

freezeColors
cbfreeze(colorbar)
str1 = sprintf('Marker 1, VUS_{1} = %4f  , TC_{C} at given pair= %4f',vus1,ROC1or);
cblabel(str1)



%====================
ROC2point=@(p1,p3) (Finv2chat(1-p3)>Finv2ahat(p1)).*(F2bhat(Finv2chat(1-p3))-F2bhat(Finv2ahat(p1)));
[pp1,pp3] = meshgrid(0:0.01:1, 0:0.01:1);
p1=pp1(1:end)';
p3=pp3(1:end)';
rr2=ROC2point(p1,p3);

p1=reshape(p1,size(pp1,1),size(pp1,2));
p3=reshape(p3,size(pp3,1),size(pp3,2));
rr2=reshape(rr2,size(pp1,1),size(pp1,2));

surf(p1,p3,rr2)
vus2=trapz((0:0.01:1)',trapz((0:0.01:1)',rr2,2),1);

xlabel('TC_{A}');ylabel('TC_{C}');zlabel('TC_{B}');

shading interp
alpha(0.7)
colormap winter
freezeColors
h1=colorbar('Location','westoutside');
str2 = sprintf('Marker 2, VUS_{2} = %4f  , TC_{C} at given pair= %4f',vus2,ROC2or);
cblabel(str2)






ROC1point=@(p1,p2) 1-F1chat(Finv1bhat(p2+F1bhat(Finv1ahat(p1))));
ROC2point=@(p1,p2) 1-F2chat(Finv2bhat(p2+F2bhat(Finv2ahat(p1))));

ROCsurf1=ROC1point;
ROCsurf2=ROC2point;

plot3(att1,0,att2,'*r','LineWidth',1)
plot3(att1,1,att2,'*r','LineWidth',1)

if ROC1point(att1,att2)<ROC2point(att1,att2)
    plot3([att1 att1],[0 ROC1point(att1,att2)],[att2 att2],'--g')
    plot3([att1 att1],[ROC2point(att1,att2) 1],[att2 att2],'--g')
else
    plot3([att1 att1],[0 ROC2point(att1,att2)],[att2 att2],'--g')
    plot3([att1 att1],[ROC1point(att1,att2) 1],[att2 att2],'--g')
end







plot3(att1,ROC1point(att1,att2),att2,'or','LineWidth',1)
plot3(att1,ROC2point(att1,att2),att2,'or','LineWidth',1)
plot3([att1 att1],[ROC1point(att1,att2) ROC2point(att1,att2)],[att2 att2], 'r','LineWidth',2)
distance=abs(ROC1point(att1,att2)-ROC2point(att1,att2));

str = sprintf('ROC surfaces, Distance at the given TC pair is= %4f\n ',abs(ROCsurf2(att1,att2)-ROCsurf1(att1,att2)));
title(str);


%=============PROJECTED ROC CURVES==========================
figure
subplot(2,2,1)
t=0:0.01:1;
roct=@(t) 1-F2chat(Finv2ahat(t));
plot(t,roct(t),'b','LineWidth',2)
auc2=trapz(t,roct(t));
hold on
roct=@(t) 1-F1chat(Finv1ahat(t));
plot(t,roct(t),'r','LineWidth',2)
auc1=trapz(t,roct(t));
xlabel('TC_{A}')
ylabel('TC_{C}')
legend(['AUC=' num2str(auc2)],['AUC=' num2str(auc1)],'Location','SouthWest');
title('ROC_{AC}')

subplot(2,2,2)
t=0:0.01:1;
roct=@(t) 1-F2bhat(Finv2ahat(t));
plot(t,roct(t),'b','LineWidth',2)
auc2=trapz(t,roct(t));
hold on
roct=@(t) 1-F1bhat(Finv1ahat(t));
plot(t,roct(t),'r','LineWidth',2)
auc1=quadgk(@(t) roct(t),0,1);
xlabel('TC_{A}')
ylabel('TC_{B}')
legend(['AUC=' num2str(auc2)],['AUC=' num2str(auc1)],'Location','SouthWest');
title('ROC_{AB}')


subplot(2,2,3)
t=0:0.01:1;
roct=@(t) 1-F2chat(Finv2bhat(t));
plot(t,roct(t),'b','LineWidth',2)
auc2=trapz(t,roct(t));
hold on
roct=@(t) 1-F1chat(Finv1bhat(t));
plot(t,roct(t),'r','LineWidth',2)
auc1=quadgk(@(t) roct(t),0,1);
xlabel('TC_{B}')
ylabel('TC_{C}')
legend(['AUC=' num2str(auc2)],['AUC=' num2str(auc1)],'Location','SouthWest');
title('ROC_{BC}')


subplot(2,2,4)
plot(att1,att2,'*r','LineWidth',1)
hold on
legend('Given pair')
t=0:0.01:1;
roct1=@(t) 1-F2bhat(Finv2ahat(t));
roct2=@(t) 1-F1bhat(Finv1ahat(t));

xx=[0 0  t 1 0];
yy=[0 1 min(roct2(t),roct1(t)) 0 0];
plot(xx,yy,'g','LineWidth',2)
hold on

xlabel('TC_{A}')
ylabel('TC_{B}')
title('Region of Feasible Given Pairs (green region)')
fill(xx,yy,'g')
plot(att1,att2,'*r','LineWidth',1)






end



