function  [distance, pvalue2t, Zstar, ROC1or, ROC2or, vus1, vus2, CIdiff]=roc3dnormal_ac(W1,W2,D,tripletabc)


W1a=W1(D==1);
W1b=W1(D==2);
W1c=W1(D==3);

W2a=W2(D==1);
W2b=W2(D==2);
W2c=W2(D==3);

na=length(W1a);
nb=length(W1b);
nc=length(W1c);

Wa=[W1a W2a];
Wb=[W1b W2b];
Wc=[W1c W2c];


if length(find(isnan(tripletabc)))~=1
    error('the tripletabc should have exactly one NaN value so that a pair is defined')
end

t=tripletabc(find(~isnan(tripletabc)));
att1=t(1);
att2=t(2);

%====================================================


D=[zeros(na,1);ones(nb,1);ones(nc,1)+1];
ca=cov([W1a W2a]);cova=ca(1,2);
cb=cov([W1b W2b]);covb=cb(1,2);
cc=cov([W1c W2c]);covc=cc(1,2);

init=[mean(W1a) sqrt(var(W1a)) mean(W1b) sqrt(var(W1b)) mean(W1c) sqrt(var(W1c)) mean(W2a) sqrt(var(W2a)) mean(W2b) sqrt(var(W2b)) mean(W2c) sqrt(var(W2c))  cova covb covc];

options=optimset('MaxFunEvals',1000000,'MaxIter',1000000,'TolX',10^(-10));




minusL=@(g) (-sum(log(mvnpdf2(Wa,[g(1) g(7)],[g(2).^2 g(13) ;g(13)  g(8).^2]))) -...
              sum(log(mvnpdf2(Wb,[g(3) g(9)],[g(4).^2 g(14);g(14) g(10).^2]))) -...
              sum(log(mvnpdf2(Wc,[g(5) g(11)],[g(6).^2 g(15);g(15) g(12).^2]))));       
   

[g gval exitflag]=fminsearch(minusL,[init],options);
%g=init;exitflag=1;

L=@(g) -((-sum(log(mvnpdf2(Wa,[g(1) g(7)],[g(2).^2 g(13) ;g(13)  g(8).^2])))-...
           sum(log(mvnpdf2(Wb,[g(3) g(9)],[g(4).^2 g(14);g(14) g(10).^2])))-...
           sum(log(mvnpdf2(Wc,[g(5) g(11)],[g(6).^2 g(15);g(15) g(12).^2])))));

m1ahat=g(1);s1ahat=g(2);m1bhat=g(3);s1bhat=g(4);m1chat=g(5);s1chat=g(6);
m2ahat=g(7);s2ahat=g(8);m2bhat=g(9);s2bhat=g(10);m2chat=g(11);s2chat=g(12);
cova=g(end-2);covb=g(end-1);covc=g(end);


posL=@(g) ((sum(log(mvnpdf2(Wa,[g(1) g(5)],[g(2).^2 g(9);g(9) g(6).^2])))+sum(log(mvnpdf2(Wb,[g(3) g(7)],[g(4).^2 g(10);g(10) g(8).^2])))).*(g(2)>0).*(g(6)>0).*(g(4)>0).*(g(8)>0));

%===============================HESSIAN IN CLOSED FORM:
Hcf=zeros(15,15);
Hcf(1,1)  =na.*(-2./(2.*s1ahat.^2 - (2.*cova.^2)./s2ahat.^2));
Hcf(2,2)  =sum((s1ahat.^4.*s2ahat.^6 + cova.^3.*(2.*m1ahat.*m2ahat.*s2ahat.^2 + 2.*W1a.*W2a.*s2ahat.^2 - 2.*W1a.*m2ahat.*s2ahat.^2 - 2.*W2a.*m1ahat.*s2ahat.^2) - s1ahat.^2.*(3.*W1a.^2.*s2ahat.^6 - 6.*W1a.*m1ahat.*s2ahat.^6 + 3.*m1ahat.^2.*s2ahat.^6) - cova.^2.*(s1ahat.^2.*(3.*W2a.^2.*s2ahat.^2 - 6.*W2a.*m2ahat.*s2ahat.^2 + 3.*m2ahat.^2.*s2ahat.^2) + W1a.^2.*s2ahat.^4 + m1ahat.^2.*s2ahat.^4 - 2.*W1a.*m1ahat.*s2ahat.^4) - cova.^4.*(W2a.^2 - 2.*W2a.*m2ahat + m2ahat.^2 + s2ahat.^2) + cova.*s1ahat.^2.*(6.*m1ahat.*m2ahat.*s2ahat.^4 + 6.*W1a.*W2a.*s2ahat.^4 - 6.*W1a.*m2ahat.*s2ahat.^4 - 6.*W2a.*m1ahat.*s2ahat.^4))./(s1ahat.^2.*s2ahat.^2 - cova.^2).^3);
Hcf(3,3)  =nb.*(-2./(2.*s1bhat.^2 - (2.*covb.^2)./s2bhat.^2));
Hcf(4,4)  =sum((s1bhat.^4.*s2bhat.^6 + covb.^3.*(2.*m1bhat.*m2bhat.*s2bhat.^2 + 2.*W1b.*W2b.*s2bhat.^2 - 2.*W1b.*m2bhat.*s2bhat.^2 - 2.*W2b.*m1bhat.*s2bhat.^2) - s1bhat.^2.*(3.*W1b.^2.*s2bhat.^6 - 6.*W1b.*m1bhat.*s2bhat.^6 + 3.*m1bhat.^2.*s2bhat.^6) - covb.^2.*(s1bhat.^2.*(3.*W2b.^2.*s2bhat.^2 - 6.*W2b.*m2bhat.*s2bhat.^2 + 3.*m2bhat.^2.*s2bhat.^2) + W1b.^2.*s2bhat.^4 + m1bhat.^2.*s2bhat.^4 - 2.*W1b.*m1bhat.*s2bhat.^4) - covb.^4.*(W2b.^2 - 2.*W2b.*m2bhat + m2bhat.^2 + s2bhat.^2) + covb.*s1bhat.^2.*(6.*m1bhat.*m2bhat.*s2bhat.^4 + 6.*W1b.*W2b.*s2bhat.^4 - 6.*W1b.*m2bhat.*s2bhat.^4 - 6.*W2b.*m1bhat.*s2bhat.^4))./(s1bhat.^2.*s2bhat.^2 - covb.^2).^3);
Hcf(5,5)  =nc.*(-2./(2.*s1chat.^2 - (2.*covc.^2)./s2chat.^2));
Hcf(6,6)  =sum((s1chat.^4.*s2chat.^6 + covc.^3.*(2.*m1chat.*m2chat.*s2chat.^2 + 2.*W1c.*W2c.*s2chat.^2 - 2.*W1c.*m2chat.*s2chat.^2 - 2.*W2c.*m1chat.*s2chat.^2) - s1chat.^2.*(3.*W1c.^2.*s2chat.^6 - 6.*W1c.*m1chat.*s2chat.^6 + 3.*m1chat.^2.*s2chat.^6) - covc.^2.*(s1chat.^2.*(3.*W2c.^2.*s2chat.^2 - 6.*W2c.*m2chat.*s2chat.^2 + 3.*m2chat.^2.*s2chat.^2) + W1c.^2.*s2chat.^4 + m1chat.^2.*s2chat.^4 - 2.*W1c.*m1chat.*s2chat.^4) - covc.^4.*(W2c.^2 - 2.*W2c.*m2chat + m2chat.^2 + s2chat.^2) + covc.*s1chat.^2.*(6.*m1chat.*m2chat.*s2chat.^4 + 6.*W1c.*W2c.*s2chat.^4 - 6.*W1c.*m2chat.*s2chat.^4 - 6.*W2c.*m1chat.*s2chat.^4))./(s1chat.^2.*s2chat.^2 - covc.^2).^3);
Hcf(7,7)  =na.*(-2./(2.*s2ahat.^2 - (2.*cova.^2)./s1ahat.^2));
Hcf(8,8)  =sum((s1ahat.^6.*s2ahat.^4 + cova.^3.*(2.*m1ahat.*m2ahat.*s1ahat.^2 + 2.*W1a.*W2a.*s1ahat.^2 - 2.*W1a.*m2ahat.*s1ahat.^2 - 2.*W2a.*m1ahat.*s1ahat.^2) - s2ahat.^2.*(3.*W2a.^2.*s1ahat.^6 - 6.*W2a.*m2ahat.*s1ahat.^6 + 3.*m2ahat.^2.*s1ahat.^6) - cova.^2.*(s2ahat.^2.*(3.*W1a.^2.*s1ahat.^2 - 6.*W1a.*m1ahat.*s1ahat.^2 + 3.*m1ahat.^2.*s1ahat.^2) + W2a.^2.*s1ahat.^4 + m2ahat.^2.*s1ahat.^4 - 2.*W2a.*m2ahat.*s1ahat.^4) - cova.^4.*(W1a.^2 - 2.*W1a.*m1ahat + m1ahat.^2 + s1ahat.^2) + cova.*s2ahat.^2.*(6.*m1ahat.*m2ahat.*s1ahat.^4 + 6.*W1a.*W2a.*s1ahat.^4 - 6.*W1a.*m2ahat.*s1ahat.^4 - 6.*W2a.*m1ahat.*s1ahat.^4))./(s1ahat.^2.*s2ahat.^2 - cova.^2).^3);
Hcf(9,9)  =nb.*(-2./(2.*s2bhat.^2 - (2.*covb.^2)./s1bhat.^2));
Hcf(10,10)=sum((s1bhat.^6.*s2bhat.^4 + covb.^3.*(2.*m1bhat.*m2bhat.*s1bhat.^2 + 2.*W1b.*W2b.*s1bhat.^2 - 2.*W1b.*m2bhat.*s1bhat.^2 - 2.*W2b.*m1bhat.*s1bhat.^2) - s2bhat.^2.*(3.*W2b.^2.*s1bhat.^6 - 6.*W2b.*m2bhat.*s1bhat.^6 + 3.*m2bhat.^2.*s1bhat.^6) - covb.^2.*(s2bhat.^2.*(3.*W1b.^2.*s1bhat.^2 - 6.*W1b.*m1bhat.*s1bhat.^2 + 3.*m1bhat.^2.*s1bhat.^2) + W2b.^2.*s1bhat.^4 + m2bhat.^2.*s1bhat.^4 - 2.*W2b.*m2bhat.*s1bhat.^4) - covb.^4.*(W1b.^2 - 2.*W1b.*m1bhat + m1bhat.^2 + s1bhat.^2) + covb.*s2bhat.^2.*(6.*m1bhat.*m2bhat.*s1bhat.^4 + 6.*W1b.*W2b.*s1bhat.^4 - 6.*W1b.*m2bhat.*s1bhat.^4 - 6.*W2b.*m1bhat.*s1bhat.^4))./(s1bhat.^2.*s2bhat.^2 - covb.^2).^3);
Hcf(11,11)=nc.*(-2./(2.*s2chat.^2 - (2.*covc.^2)./s1chat.^2));
Hcf(12,12)=sum((s1chat.^6.*s2chat.^4 + covc.^3.*(2.*m1chat.*m2chat.*s1chat.^2 + 2.*W1c.*W2c.*s1chat.^2 - 2.*W1c.*m2chat.*s1chat.^2 - 2.*W2c.*m1chat.*s1chat.^2) - s2chat.^2.*(3.*W2c.^2.*s1chat.^6 - 6.*W2c.*m2chat.*s1chat.^6 + 3.*m2chat.^2.*s1chat.^6) - covc.^2.*(s2chat.^2.*(3.*W1c.^2.*s1chat.^2 - 6.*W1c.*m1chat.*s1chat.^2 + 3.*m1chat.^2.*s1chat.^2) + W2c.^2.*s1chat.^4 + m2chat.^2.*s1chat.^4 - 2.*W2c.*m2chat.*s1chat.^4) - covc.^4.*(W1c.^2 - 2.*W1c.*m1chat + m1chat.^2 + s1chat.^2) + covc.*s2chat.^2.*(6.*m1chat.*m2chat.*s1chat.^4 + 6.*W1c.*W2c.*s1chat.^4 - 6.*W1c.*m2chat.*s1chat.^4 - 6.*W2c.*m1chat.*s1chat.^4))./(s1chat.^2.*s2chat.^2 - covc.^2).^3);
Hcf(13,13)=sum(-(cova.^2.*((3.*W2a.^2 - 6.*W2a.*m2ahat + 3.*m2ahat.^2).*s1ahat.^2 + (3.*W1a.^2 - 6.*W1a.*m1ahat + 3.*m1ahat.^2).*s2ahat.^2) - cova.^3.*(2.*W1a.*W2a - 2.*W1a.*m2ahat - 2.*W2a.*m1ahat + 2.*m1ahat.*m2ahat) + cova.^4 + s2ahat.^4.*(s1ahat.^2.*(W1a.^2 - 2.*W1a.*m1ahat + m1ahat.^2) - s1ahat.^4) + s1ahat.^4.*s2ahat.^2.*(W2a.^2 - 2.*W2a.*m2ahat + m2ahat.^2) - cova.*s1ahat.^2.*s2ahat.^2.*(6.*W1a.*W2a - 6.*W1a.*m2ahat - 6.*W2a.*m1ahat + 6.*m1ahat.*m2ahat))./(s1ahat.^2.*s2ahat.^2 - cova.^2).^3);
Hcf(14,14)=sum(-(covb.^2.*((3.*W2b.^2 - 6.*W2b.*m2bhat + 3.*m2bhat.^2).*s1bhat.^2 + (3.*W1b.^2 - 6.*W1b.*m1bhat + 3.*m1bhat.^2).*s2bhat.^2) - covb.^3.*(2.*W1b.*W2b - 2.*W1b.*m2bhat - 2.*W2b.*m1bhat + 2.*m1bhat.*m2bhat) + covb.^4 + s2bhat.^4.*(s1bhat.^2.*(W1b.^2 - 2.*W1b.*m1bhat + m1bhat.^2) - s1bhat.^4) + s1bhat.^4.*s2bhat.^2.*(W2b.^2 - 2.*W2b.*m2bhat + m2bhat.^2) - covb.*s1bhat.^2.*s2bhat.^2.*(6.*W1b.*W2b - 6.*W1b.*m2bhat - 6.*W2b.*m1bhat + 6.*m1bhat.*m2bhat))./(s1bhat.^2.*s2bhat.^2 - covb.^2).^3);
Hcf(15,15)=sum(-(covc.^2.*((3.*W2c.^2 - 6.*W2c.*m2chat + 3.*m2chat.^2).*s1chat.^2 + (3.*W1c.^2 - 6.*W1c.*m1chat + 3.*m1chat.^2).*s2chat.^2) - covc.^3.*(2.*W1c.*W2c - 2.*W1c.*m2chat - 2.*W2c.*m1chat + 2.*m1chat.*m2chat) + covc.^4 + s2chat.^4.*(s1chat.^2.*(W1c.^2 - 2.*W1c.*m1chat + m1chat.^2) - s1chat.^4) + s1chat.^4.*s2chat.^2.*(W2c.^2 - 2.*W2c.*m2chat + m2chat.^2) - covc.*s1chat.^2.*s2chat.^2.*(6.*W1c.*W2c - 6.*W1c.*m2chat - 6.*W2c.*m1chat + 6.*m1chat.*m2chat))./(s1chat.^2.*s2chat.^2 - covc.^2).^3);

Hcf(1,7)  =na.*(cova./(- cova.^2 + s1ahat.^2.*s2ahat.^2));
Hcf(2,8)  =sum(((s1ahat.^3.*(2.*cova.*(2.*W1a.*W2a - 2.*W1a.*m2ahat - 2.*W2a.*m1ahat + 2.*m1ahat.*m2ahat) + 2.*cova.^2) - cova.^2.*s1ahat.*(4.*W1a.^2 - 8.*W1a.*m1ahat + 4.*m1ahat.^2)).*s2ahat.^3 + (s1ahat.*(2.*cova.^3.*(2.*W1a.*W2a - 2.*W1a.*m2ahat - 2.*W2a.*m1ahat + 2.*m1ahat.*m2ahat) - 2.*cova.^4) - cova.^2.*s1ahat.^3.*(4.*W2a.^2 - 8.*W2a.*m2ahat + 4.*m2ahat.^2)).*s2ahat)./(s1ahat.^2.*s2ahat.^2 - cova.^2).^3);
Hcf(3,9)  =nb.*(covb./(- covb.^2 + s1bhat.^2.*s2bhat.^2));
Hcf(4,10) =sum(((s1bhat.^3.*(2.*covb.*(2.*W1b.*W2b - 2.*W1b.*m2bhat - 2.*W2b.*m1bhat + 2.*m1bhat.*m2bhat) + 2.*covb.^2) - covb.^2.*s1bhat.*(4.*W1b.^2 - 8.*W1b.*m1bhat + 4.*m1bhat.^2)).*s2bhat.^3 + (s1bhat.*(2.*covb.^3.*(2.*W1b.*W2b - 2.*W1b.*m2bhat - 2.*W2b.*m1bhat + 2.*m1bhat.*m2bhat) - 2.*covb.^4) - covb.^2.*s1bhat.^3.*(4.*W2b.^2 - 8.*W2b.*m2bhat + 4.*m2bhat.^2)).*s2bhat)./(s1bhat.^2.*s2bhat.^2 - covb.^2).^3);
Hcf(5,11) =nc.*(covc./(- covc.^2 + s1chat.^2.*s2chat.^2));
Hcf(6,12) =sum(((s1chat.^3.*(2.*covc.*(2.*W1c.*W2c - 2.*W1c.*m2chat - 2.*W2c.*m1chat + 2.*m1chat.*m2chat) + 2.*covc.^2) - covc.^2.*s1chat.*(4.*W1c.^2 - 8.*W1c.*m1chat + 4.*m1chat.^2)).*s2chat.^3 + (s1chat.*(2.*covc.^3.*(2.*W1c.*W2c - 2.*W1c.*m2chat - 2.*W2c.*m1chat + 2.*m1chat.*m2chat) - 2.*covc.^4) - covc.^2.*s1chat.^3.*(4.*W2c.^2 - 8.*W2c.*m2chat + 4.*m2chat.^2)).*s2chat)./(s1chat.^2.*s2chat.^2 - covc.^2).^3);
Hcf(8,13) =sum(((- s1ahat.^4.*(2.*W1a.*W2a - 2.*W1a.*m2ahat - 2.*W2a.*m1ahat + 2.*m1ahat.*m2ahat) - cova.*(2.*s1ahat.^4 - s1ahat.^2.*(2.*W1a.^2 - 4.*W1a.*m1ahat + 2.*m1ahat.^2))).*s2ahat.^3 + (cova.^3.*(2.*W1a.^2 - 4.*W1a.*m1ahat + 2.*m1ahat.^2 + 2.*s1ahat.^2) + cova.*s1ahat.^4.*(4.*W2a.^2 - 8.*W2a.*m2ahat + 4.*m2ahat.^2) - cova.^2.*s1ahat.^2.*(6.*W1a.*W2a - 6.*W1a.*m2ahat - 6.*W2a.*m1ahat + 6.*m1ahat.*m2ahat)).*s2ahat)./(s1ahat.^2.*s2ahat.^2 - cova.^2).^3);
Hcf(10,14)=sum(((- s1bhat.^4.*(2.*W1b.*W2b - 2.*W1b.*m2bhat - 2.*W2b.*m1bhat + 2.*m1bhat.*m2bhat) - covb.*(2.*s1bhat.^4 - s1bhat.^2.*(2.*W1b.^2 - 4.*W1b.*m1bhat + 2.*m1bhat.^2))).*s2bhat.^3 + (covb.^3.*(2.*W1b.^2 - 4.*W1b.*m1bhat + 2.*m1bhat.^2 + 2.*s1bhat.^2) + covb.*s1bhat.^4.*(4.*W2b.^2 - 8.*W2b.*m2bhat + 4.*m2bhat.^2) - covb.^2.*s1bhat.^2.*(6.*W1b.*W2b - 6.*W1b.*m2bhat - 6.*W2b.*m1bhat + 6.*m1bhat.*m2bhat)).*s2bhat)./(s1bhat.^2.*s2bhat.^2 - covb.^2).^3);
Hcf(12,15)=sum(((- s1chat.^4.*(2.*W1c.*W2c - 2.*W1c.*m2chat - 2.*W2c.*m1chat + 2.*m1chat.*m2chat) - covc.*(2.*s1chat.^4 - s1chat.^2.*(2.*W1c.^2 - 4.*W1c.*m1chat + 2.*m1chat.^2))).*s2chat.^3 + (covc.^3.*(2.*W1c.^2 - 4.*W1c.*m1chat + 2.*m1chat.^2 + 2.*s1chat.^2) + covc.*s1chat.^4.*(4.*W2c.^2 - 8.*W2c.*m2chat + 4.*m2chat.^2) - covc.^2.*s1chat.^2.*(6.*W1c.*W2c - 6.*W1c.*m2chat - 6.*W2c.*m1chat + 6.*m1chat.*m2chat)).*s2chat)./(s1chat.^2.*s2chat.^2 - covc.^2).^3);

Hcf(2,13)=sum(((- s2ahat.^4.*(2.*W1a.*W2a - 2.*W1a.*m2ahat - 2.*W2a.*m1ahat + 2.*m1ahat.*m2ahat) - cova.*(2.*s2ahat.^4 - s2ahat.^2.*(2.*W2a.^2 - 4.*W2a.*m2ahat + 2.*m2ahat.^2))).*s1ahat.^3 + (cova.^3.*(2.*W2a.^2 - 4.*W2a.*m2ahat + 2.*m2ahat.^2 + 2.*s2ahat.^2) + cova.*s2ahat.^4.*(4.*W1a.^2 - 8.*W1a.*m1ahat + 4.*m1ahat.^2) - cova.^2.*s2ahat.^2.*(6.*W1a.*W2a - 6.*W1a.*m2ahat - 6.*W2a.*m1ahat + 6.*m1ahat.*m2ahat)).*s1ahat)./(s1ahat.^2.*s2ahat.^2 - cova.^2).^3);
Hcf(4,14)=sum(((- s2bhat.^4.*(2.*W1b.*W2b - 2.*W1b.*m2bhat - 2.*W2b.*m1bhat + 2.*m1bhat.*m2bhat) - covb.*(2.*s2bhat.^4 - s2bhat.^2.*(2.*W2b.^2 - 4.*W2b.*m2bhat + 2.*m2bhat.^2))).*s1bhat.^3 + (covb.^3.*(2.*W2b.^2 - 4.*W2b.*m2bhat + 2.*m2bhat.^2 + 2.*s2bhat.^2) + covb.*s2bhat.^4.*(4.*W1b.^2 - 8.*W1b.*m1bhat + 4.*m1bhat.^2) - covb.^2.*s2bhat.^2.*(6.*W1b.*W2b - 6.*W1b.*m2bhat - 6.*W2b.*m1bhat + 6.*m1bhat.*m2bhat)).*s1bhat)./(s1bhat.^2.*s2bhat.^2 - covb.^2).^3);
Hcf(6,15)=sum(((- s2chat.^4.*(2.*W1c.*W2c - 2.*W1c.*m2chat - 2.*W2c.*m1chat + 2.*m1chat.*m2chat) - covc.*(2.*s2chat.^4 - s2chat.^2.*(2.*W2c.^2 - 4.*W2c.*m2chat + 2.*m2chat.^2))).*s1chat.^3 + (covc.^3.*(2.*W2c.^2 - 4.*W2c.*m2chat + 2.*m2chat.^2 + 2.*s2chat.^2) + covc.*s2chat.^4.*(4.*W1c.^2 - 8.*W1c.*m1chat + 4.*m1chat.^2) - covc.^2.*s2chat.^2.*(6.*W1c.*W2c - 6.*W1c.*m2chat - 6.*W2c.*m1chat + 6.*m1chat.*m2chat)).*s1chat)./(s1chat.^2.*s2chat.^2 - covc.^2).^3);

Hcf(7,1)  =Hcf(1,7);
Hcf(8,2)  =Hcf(2,8);
Hcf(9,3)  =Hcf(3,9);
Hcf(10,4) =Hcf(4,10);
Hcf(11,5) =Hcf(5,11);
Hcf(12,6) =Hcf(6,12);
Hcf(13,8) =Hcf(8,13);
Hcf(14,10)=Hcf(10,14);
Hcf(15,12)=Hcf(12,15);

Hcf(13,2)=Hcf(2,13);
Hcf(14,4)=Hcf(4,14);
Hcf(15,6)=Hcf(6,15);

%H
Hcf;



%break



%===============================END HESSIAN IN CLOSED FORM

H=Hcf;
VV=inv(-H);

pars=[m1ahat s1ahat m1bhat s1bhat m1chat s1chat m2ahat s2ahat m2bhat s2bhat m2chat s2chat];

ROCsurf1=@(p1,p3) (norminv(1-p3,m1chat,s1chat)>norminv(p1,m1ahat,s1ahat)).*(normcdf(norminv(1-p3,m1chat,s1chat),m1bhat,s1bhat)-normcdf(norminv(p1,m1ahat,s1ahat),m1bhat,s1bhat));


ROC1=@(p1,p3) (normcdf((s1chat*norminv(1-p3)+m1chat-m1bhat)./(s1bhat))-...
               normcdf((s1ahat*norminv(p1  )+m1ahat-m1bhat)./(s1bhat))).*(((s1chat*norminv(1-p3)+m1chat-m1bhat)./(s1bhat))>((s1ahat*norminv(p1  )+m1ahat-m1bhat)./(s1bhat)));

ROC2=@(p1,p3) (normcdf((s2chat*norminv(1-p3)+m2chat-m2bhat)./(s2bhat))-...
              normcdf((s2ahat*norminv(p1  )+m2ahat-m2bhat)./(s2bhat))).*(((s2chat*norminv(1-p3)+m2chat-m2bhat)./(s2bhat))>((s2ahat*norminv(p1  )+m2ahat-m2bhat)./(s2bhat)));


ROC1MC =norminv(ROC1(att1,att2));
ROC2MC =norminv(ROC2(att1,att2));
ROC1or=ROC1(att1,att2);
ROC2or=ROC2(att1,att2);


p1=att1;p3=att2;
%====================ROC1==============================

dm1ahat =-(exp(erfcinv(erf((2^(1/2)*(m1bhat - m1ahat + 2^(1/2)*s1ahat*erfcinv(2*p1)))/(2*s1bhat)) + erf((2^(1/2)*(m1chat - m1bhat + 2^(1/2)*s1chat*erfcinv(2*p3)))/(2*s1bhat)))^2)*exp(-(m1bhat - m1ahat + 2^(1/2)*s1ahat*erfcinv(2*p1))^2/(2*s1bhat^2)))/s1bhat;
ds1ahat =(2^(1/2)*erfcinv(2*p1)*exp(erfcinv(erf((2^(1/2)*(m1bhat - m1ahat + 2^(1/2)*s1ahat*erfcinv(2*p1)))/(2*s1bhat)) + erf((2^(1/2)*(m1chat - m1bhat + 2^(1/2)*s1chat*erfcinv(2*p3)))/(2*s1bhat)))^2)*exp(-(m1bhat - m1ahat + 2^(1/2)*s1ahat*erfcinv(2*p1))^2/(2*s1bhat^2)))/s1bhat;
dm1bhat =(2^(1/2)*pi^(1/2)*exp(erfcinv(erf((2^(1/2)*(m1bhat - m1ahat + 2^(1/2)*s1ahat*erfcinv(2*p1)))/(2*s1bhat)) + erf((2^(1/2)*(m1chat - m1bhat + 2^(1/2)*s1chat*erfcinv(2*p3)))/(2*s1bhat)))^2)*((2^(1/2)*exp(-(m1bhat - m1ahat + 2^(1/2)*s1ahat*erfcinv(2*p1))^2/(2*s1bhat^2)))/(pi^(1/2)*s1bhat) - (2^(1/2)*exp(-(m1chat - m1bhat + 2^(1/2)*s1chat*erfcinv(2*p3))^2/(2*s1bhat^2)))/(pi^(1/2)*s1bhat)))/2;
ds1bhat =-(2^(1/2)*pi^(1/2)*exp(erfcinv(erf((2^(1/2)*(m1bhat - m1ahat + 2^(1/2)*s1ahat*erfcinv(2*p1)))/(2*s1bhat)) + erf((2^(1/2)*(m1chat - m1bhat + 2^(1/2)*s1chat*erfcinv(2*p3)))/(2*s1bhat)))^2)*((2^(1/2)*exp(-(m1bhat - m1ahat + 2^(1/2)*s1ahat*erfcinv(2*p1))^2/(2*s1bhat^2))*(m1bhat - m1ahat + 2^(1/2)*s1ahat*erfcinv(2*p1)))/(pi^(1/2)*s1bhat^2) + (2^(1/2)*exp(-(m1chat - m1bhat + 2^(1/2)*s1chat*erfcinv(2*p3))^2/(2*s1bhat^2))*(m1chat - m1bhat + 2^(1/2)*s1chat*erfcinv(2*p3)))/(pi^(1/2)*s1bhat^2)))/2;
dm1chat =(exp(erfcinv(erf((2^(1/2)*(m1bhat - m1ahat + 2^(1/2)*s1ahat*erfcinv(2*p1)))/(2*s1bhat)) + erf((2^(1/2)*(m1chat - m1bhat + 2^(1/2)*s1chat*erfcinv(2*p3)))/(2*s1bhat)))^2)*exp(-(m1chat - m1bhat + 2^(1/2)*s1chat*erfcinv(2*p3))^2/(2*s1bhat^2)))/s1bhat;
ds1chat =(2^(1/2)*erfcinv(2*p3)*exp(erfcinv(erf((2^(1/2)*(m1bhat - m1ahat + 2^(1/2)*s1ahat*erfcinv(2*p1)))/(2*s1bhat)) + erf((2^(1/2)*(m1chat - m1bhat + 2^(1/2)*s1chat*erfcinv(2*p3)))/(2*s1bhat)))^2)*exp(-(m1chat - m1bhat + 2^(1/2)*s1chat*erfcinv(2*p3))^2/(2*s1bhat^2)))/s1bhat;
  
varROC1 =[dm1ahat ds1ahat dm1bhat ds1bhat dm1chat ds1chat]*VV(1:6,1:6)*[dm1ahat ds1ahat dm1bhat ds1bhat dm1chat ds1chat]';

%====================ROC2==============================
dm2ahat =-(exp(erfcinv(erf((2^(1/2)*(m2bhat - m2ahat + 2^(1/2)*s2ahat*erfcinv(2*p1)))/(2*s2bhat)) + erf((2^(1/2)*(m2chat - m2bhat + 2^(1/2)*s2chat*erfcinv(2*p3)))/(2*s2bhat)))^2)*exp(-(m2bhat - m2ahat + 2^(1/2)*s2ahat*erfcinv(2*p1))^2/(2*s2bhat^2)))/s2bhat;
ds2ahat =(2^(1/2)*erfcinv(2*p1)*exp(erfcinv(erf((2^(1/2)*(m2bhat - m2ahat + 2^(1/2)*s2ahat*erfcinv(2*p1)))/(2*s2bhat)) + erf((2^(1/2)*(m2chat - m2bhat + 2^(1/2)*s2chat*erfcinv(2*p3)))/(2*s2bhat)))^2)*exp(-(m2bhat - m2ahat + 2^(1/2)*s2ahat*erfcinv(2*p1))^2/(2*s2bhat^2)))/s2bhat;
dm2bhat =(2^(1/2)*pi^(1/2)*exp(erfcinv(erf((2^(1/2)*(m2bhat - m2ahat + 2^(1/2)*s2ahat*erfcinv(2*p1)))/(2*s2bhat)) + erf((2^(1/2)*(m2chat - m2bhat + 2^(1/2)*s2chat*erfcinv(2*p3)))/(2*s2bhat)))^2)*((2^(1/2)*exp(-(m2bhat - m2ahat + 2^(1/2)*s2ahat*erfcinv(2*p1))^2/(2*s2bhat^2)))/(pi^(1/2)*s2bhat) - (2^(1/2)*exp(-(m2chat - m2bhat + 2^(1/2)*s2chat*erfcinv(2*p3))^2/(2*s2bhat^2)))/(pi^(1/2)*s2bhat)))/2;
ds2bhat =-(2^(1/2)*pi^(1/2)*exp(erfcinv(erf((2^(1/2)*(m2bhat - m2ahat + 2^(1/2)*s2ahat*erfcinv(2*p1)))/(2*s2bhat)) + erf((2^(1/2)*(m2chat - m2bhat + 2^(1/2)*s2chat*erfcinv(2*p3)))/(2*s2bhat)))^2)*((2^(1/2)*exp(-(m2bhat - m2ahat + 2^(1/2)*s2ahat*erfcinv(2*p1))^2/(2*s2bhat^2))*(m2bhat - m2ahat + 2^(1/2)*s2ahat*erfcinv(2*p1)))/(pi^(1/2)*s2bhat^2) + (2^(1/2)*exp(-(m2chat - m2bhat + 2^(1/2)*s2chat*erfcinv(2*p3))^2/(2*s2bhat^2))*(m2chat - m2bhat + 2^(1/2)*s2chat*erfcinv(2*p3)))/(pi^(1/2)*s2bhat^2)))/2;
dm2chat =(exp(erfcinv(erf((2^(1/2)*(m2bhat - m2ahat + 2^(1/2)*s2ahat*erfcinv(2*p1)))/(2*s2bhat)) + erf((2^(1/2)*(m2chat - m2bhat + 2^(1/2)*s2chat*erfcinv(2*p3)))/(2*s2bhat)))^2)*exp(-(m2chat - m2bhat + 2^(1/2)*s2chat*erfcinv(2*p3))^2/(2*s2bhat^2)))/s2bhat;
ds2chat =(2^(1/2)*erfcinv(2*p3)*exp(erfcinv(erf((2^(1/2)*(m2bhat - m2ahat + 2^(1/2)*s2ahat*erfcinv(2*p1)))/(2*s2bhat)) + erf((2^(1/2)*(m2chat - m2bhat + 2^(1/2)*s2chat*erfcinv(2*p3)))/(2*s2bhat)))^2)*exp(-(m2chat - m2bhat + 2^(1/2)*s2chat*erfcinv(2*p3))^2/(2*s2bhat^2)))/s2bhat;
   
varROC2 =[dm2ahat ds2ahat dm2bhat ds2bhat dm2chat ds2chat]*VV(7:12,7:12)*[dm2ahat ds2ahat dm2bhat ds2bhat dm2chat ds2chat]';

%====================cov ROC2==============================

covROC =[dm1ahat ds1ahat dm1bhat ds1bhat dm1chat ds1chat 0 0 0 0 0 0]*VV(1:12,1:12)*[0 0 0 0 0 0 dm2ahat ds2ahat dm2bhat ds2bhat dm2chat ds2chat]';

Z =(ROC2MC -ROC1MC )./(sqrt(varROC1 +varROC2 -2*covROC ));
SE=sqrt(varROC1 +varROC2 -2*covROC );
CIdiff=[(ROC2MC -ROC1MC )-1.96*SE (ROC2MC -ROC1MC )+1.96*SE];
sortci=sort(CIdiff);


ROCsurf1=@(p1,p3) (norminv(1-p3,m1chat,s1chat)>norminv(p1,m1ahat,s1ahat)).*(normcdf(norminv(1-p3,m1chat,s1chat),m1bhat,s1bhat)-normcdf(norminv(p1,m1ahat,s1ahat),m1bhat,s1bhat));
ROCsurf2=@(p1,p3) (norminv(1-p3,m2chat,s2chat)>norminv(p1,m2ahat,s2ahat)).*(normcdf(norminv(1-p3,m2chat,s2chat),m2bhat,s2bhat)-normcdf(norminv(p1,m2ahat,s2ahat),m2bhat,s2bhat));
vus1=integral2(ROCsurf1,0,1,0,1);
vus2=integral2(ROCsurf2,0,1,0,1);



Z;Zstar=Z;
SE;
pvalue2t=2*normcdf(-abs(Z));

%----plot the ROC surface:
[p1,p3] = meshgrid(0:0.01:1, 0:0.01:1);
ROCsparam= (norminv(1-p3,m1chat,s1chat)>norminv(p1,m1ahat,s1ahat)).*(normcdf(norminv(1-p3,m1chat,s1chat),m1bhat,s1bhat)-normcdf(norminv(p1,m1ahat,s1ahat),m1bhat,s1bhat));
surf(p1,p3,ROCsparam) %plot the ROC surface
hold on
xlabel('p_{A}');ylabel('p_{C}');zlabel('p_{B}');

shading interp
axis vis3d
colormap hot

freezeColors
cbfreeze(colorbar)
str1 = sprintf('Marker 1, VUS_{1} = %4f  , TC_{B} at given pair= %4f',vus1,ROCsurf1(att1,att2));
cblabel(str1)
%-------------------
ROCsparam= (norminv(1-p3,m2chat,s2chat)>norminv(p1,m2ahat,s2ahat)).*(normcdf(norminv(1-p3,m2chat,s2chat),m2bhat,s2bhat)-normcdf(norminv(p1,m2ahat,s2ahat),m2bhat,s2bhat));
RR=ROCsparam;
surf(p1,p3,ROCsparam) %plot the ROC surface
xlabel('TC_{A}');ylabel('TC_{C}');zlabel('TC_{B}');

shading interp
alpha(0.7)
colormap winter
freezeColors
h1=colorbar('Location','westoutside');
str2 = sprintf('Marker 2, VUS_{2} = %4f  , TC_{B} at given pair= %4f',vus2,ROCsurf2(att1,att2));
cblabel(str2)


ROCsurf1=@(p1,p3) (norminv(1-p3,m1chat,s1chat)>norminv(p1,m1ahat,s1ahat)).*(normcdf(norminv(1-p3,m1chat,s1chat),m1bhat,s1bhat)-normcdf(norminv(p1,m1ahat,s1ahat),m1bhat,s1bhat));
ROCsurf2=@(p1,p3) (norminv(1-p3,m2chat,s2chat)>norminv(p1,m2ahat,s2ahat)).*(normcdf(norminv(1-p3,m2chat,s2chat),m2bhat,s2bhat)-normcdf(norminv(p1,m2ahat,s2ahat),m2bhat,s2bhat));

plot3(att1,att2,0,'*r','LineWidth',1)
plot3(att1,att2,1,'*r','LineWidth',1)

if ROCsurf1(att1,att2)<ROCsurf1(att1,att2)
    plot3([att1 att1],[att2 att2],[0 ROCsurf1(att1,att2)],'--g')
    plot3([att1 att1],[att2 att2],[ROCsurf2(att1,att2) 1],'--g')
else
    plot3([att1 att1],[att2 att2],[0 ROCsurf2(att1,att2)],'--g')
    plot3([att1 att1],[att2 att2],[ROCsurf1(att1,att2) 1],'--g')
end



vus1=integral2(ROCsurf1,0,1,0,1);
plot3(att1,att2,ROCsurf1(att1,att2),'or','LineWidth',1)



vus2=integral2(ROCsurf2,0,1,0,1);
plot3(att1,att2,ROCsurf2(att1,att2),'or','LineWidth',1)
plot3([att1 att1],[att2 att2],[ROCsurf1(att1,att2) ROCsurf2(att1,att2)], 'r','LineWidth',2)

distance=abs(ROCsurf1(att1,att2)-ROCsurf2(att1,att2));


str = sprintf('ROC surfaces, Distance at the given TC pair is= %4f\n ',abs(ROCsurf2(att1,att2)-ROCsurf1(att1,att2)));
title(str);

%=============PROJECTED ROC CURVES==========================
figure
subplot(2,2,1)
t=0:0.01:1;
roct=@(t) 1-normcdf(norminv(t,m2ahat,s2ahat),m2chat,s2chat);
plot(t,roct(t),'b','LineWidth',2)
auc2=quadgk(@(t) roct(t),0,1);
hold on
roct=@(t) 1-normcdf(norminv(t,m1ahat,s1ahat),m1chat,s1chat);
plot(t,roct(t),'r','LineWidth',2)
auc1=quadgk(@(t) roct(t),0,1);
xlabel('TC_{A}')
ylabel('TC_{C}')
legend(['AUC=' num2str(auc2)],['AUC=' num2str(auc1)],'Location','SouthWest');
title('ROC_{AC}')

subplot(2,2,2)
t=0:0.01:1;
roct=@(t) 1-normcdf(norminv(t,m2ahat,s2ahat),m2bhat,s2bhat);
plot(t,roct(t),'b','LineWidth',2)
auc2=quadgk(@(t) roct(t),0,1);
hold on
roct=@(t) 1-normcdf(norminv(t,m1ahat,s1ahat),m1bhat,s1bhat);
plot(t,roct(t),'r','LineWidth',2)
auc1=quadgk(@(t) roct(t),0,1);
xlabel('TC_{A}')
ylabel('TC_{B}')
legend(['AUC=' num2str(auc2)],['AUC=' num2str(auc1)],'Location','SouthWest');
title('ROC_{AB}')


subplot(2,2,3)
t=0:0.01:1;
roct=@(t) 1-normcdf(norminv(t,m2bhat,s2bhat),m2chat,s2chat);
plot(t,roct(t),'b','LineWidth',2)
auc2=quadgk(@(t) roct(t),0,1);
hold on
roct=@(t) 1-normcdf(norminv(t,m1bhat,s1bhat),m1chat,s1chat);
plot(t,roct(t),'r','LineWidth',2)
auc1=quadgk(@(t) roct(t),0,1);
xlabel('TC_{B}')
ylabel('TC_{C}')
legend(['AUC=' num2str(auc2)],['AUC=' num2str(auc1)],'Location','SouthWest');
title('ROC_{BC}')


subplot(2,2,4)
plot(att1,att2,'*r','LineWidth',1)
hold on
legend('Given pair')
t=0:0.01:1;
roct1=@(t) 1-normcdf(norminv(t,m2ahat,s2ahat),m2chat,s2chat);
roct2=@(t) 1-normcdf(norminv(t,m1ahat,s1ahat),m1chat,s1chat);

xx=[0 0  t 1 0];
yy=[0 1 min(roct2(t),roct1(t)) 0 0];
plot(xx,yy,'g','LineWidth',2)
hold on

xlabel('TC_{A}')
ylabel('TC_{C}')
title('Region of Feasible Given Pairs (green region)')
fill(xx,yy,'g')
plot(att1,att2,'*r','LineWidth',1)



end